!{\src2tex{textfont=tt}}
!!****p* creation_chi0/create_den2
!! NAME
!! create_den2
!!
!! FUNCTION
!! Create the denominator of chi0drude for this (it) transition
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! creation_chi0drude
!!
!! SOURCE
subroutine create_den2(iparam,it,iq,transdrude,den)

 use ggwdef
 use dpdef

 implicit none
 
 type(dpparam) iparam
 type(transition) transdrude(iparam%ndtmax,iparam%nqpol)
 integer ibv, ibc, it, ikbz, isppol, iq
 complex (kind(0.0d0)) :: den(iparam%nomega),egwdiff
 double precision factocc,  sumlifetime

 ikbz = transdrude(it,iq)%k
 ibv = transdrude(it,iq)%v
 ibc = transdrude(it,iq)%c
 isppol =  transdrude(it,iq)%s
 factocc = transdrude(it,iq)%factocc
 egwdiff = dcmplx(transdrude(it,iq)%en,0.0)

! if (iparam%lifetime) then
!  sumlifetime = abs(elecstr%imsigma(ikibz,ibc,isppol))+abs(elecstr%imsigma(ikpibz,ibv,isppol))
! else
  sumlifetime = 0.0
! endif 

! factor 0.5 added to take into account the fact that for each k is included also the contribution for -k
   den(:)=dcmplx(factocc*0.5,0.0)/(iparam%omega(:)-egwdiff+dcmplx(0.0,sumlifetime))

end subroutine create_den2
!!***
