!{\src2tex{textfont=tt}}
!!****p* creation_Wtt/evaluate_memory
!! NAME
!! evaluate_memory
!!
!! FUNCTION
!! evaluation of memory usage 
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! creation_Wtt
!! 
!! SOURCE
 subroutine evaluate_memory(iparam)
 use dpdef
 use verbose
 implicit none
 type(dpparam) iparam
 integer dimoscillator,dimchi0,dimwings
 
 if(iverbose>2)call uverbose('b','evaluate_memory')
 
 dimoscillator = iparam%nt*iparam%npwmat*8/1024
 if (.not.iparam%td) dimoscillator = 2*dimoscillator
 dimchi0 = iparam%npwmat*iparam%npwmat*iparam%nomega*8/1024
 dimwings = 2*iparam%nqpol*iparam%npwmat*iparam%nomega*8/1024
 
 headline='Evaluation of memory usage'
 call print_headline()
 write(uout,*)
 write(uout,fmt='("oscillator strengths (Nt*Ng) = ",I9," kb")')dimoscillator
 write(uout,fmt='("   chi0           (Ng*Ng*Nw) = ",I9," kb")')dimchi0
 write(uout,fmt='("  wings         2*(Nq*Ng*Nw) = ",I9," kb")')dimwings
 call print_footline()
 if(iverbose>2)call uverbose('e','evaluate_memory')
 end
!!***
