!!****p* creation_epsrpa/get_pols
!! NAME
!! get_pols
!!
!! FUNCTION
!! creates the correct indeces of the dielectric tensor in such a way that
!!          | xx  xy  xz |
!!  \eps =  | b1  yy  yz |
!!          | b2  b3  zz | 
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! creation_epsrpa, creation_epslda, creation_epsalt
!!
!! SOURCE

subroutine get_pols(nqpol,iqpol1,iqpol2,pol1,pol2,irpol)
implicit none
integer :: nqpol,iqpol1,iqpol2,pol1,pol2,irpol

 if(nqpol == 1) then
  irpol = 1
  pol1 = 1
  pol2 = 1
 else
  if (iqpol1 == 1 ) then
   if (iqpol2 == 1 ) then
    irpol = 4
    pol1 = 4
    pol2 = 4
   else if (iqpol2 == 2 ) then
    irpol = 9
    pol1 = 4
    pol2 = 5
   else if (iqpol2 == 3 ) then
    irpol = 10
    pol1 = 4
    pol2 = 6
   endif
  else if (iqpol1 == 2 ) then
   if (iqpol2 == 1 ) then
    irpol = 1
    pol1 = 1
    pol2 = 1
   else if (iqpol2 == 2 ) then
    irpol = 5
    pol1 = 5
    pol2 = 5
   else if (iqpol2 == 3 ) then
    irpol = 11
    pol1 = 5
    pol2 = 6
   endif
  else if (iqpol1 == 3 ) then
   if (iqpol2 == 1 ) then
    irpol = 2
    pol1 = 2
    pol2 = 2
   else if (iqpol2 == 2 ) then
    irpol = 3
    pol1 = 3
    pol2 = 3
   else if (iqpol2 == 3 ) then
    irpol = 6
    pol1 = 6
    pol2 = 6
   endif
  endif
 endif

end subroutine get_pols
!!***
