!{\src2tex{textfont=tt}}
!!****p* handling_files/lrec
!! NAME
!! lrec
!!
!! FUNCTION
!! find the record lenght of a real on a given machine
!! machine independent
!! 
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! handling_files, blocks, exceig
!!
!! SOURCE
!==================================================================
 integer function lrec()
!==================================================================
!------------------------------------------------------------------
 implicit none
 real pi, e, pir, er
 integer i
 integer, parameter :: iu=99
 character(len=15) :: namefile
#ifdef MPI
 include 'mpif.h'
 integer ierr,rang,nprocs
 character(len=4) :: tag
 call mpi_comm_size(mpi_comm_world,nprocs,ierr)
 call mpi_comm_rank(mpi_comm_world,rang,ierr)
 if(rang<10) write(tag,'(i1)') rang
 if(rang >= 10 .and. rang < 100) write(tag,'(i2)') rang
 if(rang >= 100 .and. rang < 1000) write(tag,'(i3)') rang
 namefile=trim('lrec.tmp.'//tag)
#else
 namefile='lrec.tmp'
#endif
 

 pi = 4.0 * atan(1.0)
 e = exp(1.0)
!not found!           
 lrec = 0
 do i = 1, 256
   open(iu,file=namefile,status='unknown',access='direct',recl=i)
   write(iu,rec=1,err=100) pi
   write(iu,rec=2,err=100) e
   read(iu,rec=1,err=100) pir
   read(iu,rec=2,err=100) er
   if(abs(pir-pi)<0.000001 .and. abs(er-e)<0.000001) then
!  if(pir == pi .and er == e) then ! this does not work on ifc linux
!    dimension found!
     lrec = i
     exit
   endif
100 continue           
   close(iu)
 enddo
 close(iu,status='delete')
 if(lrec == 0) stop 'lrec not found'
 end
!!***
