!{\src2tex{textfont=tt}}
!!****p* main/header
!! NAME
!! header
!!
!! FUNCTION
!! Message subroutine (beginning message, error messages, warnings, etc) 
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! main
!!
!! CHILDREN
!! mesg
!!
!! SOURCE

subroutine header(code,inputfile,il)

implicit none

integer, external :: read_int, read_string, read_float, read_file
logical :: dp,exc,plexc
character(*) :: code
integer :: idum,il
character(len=il) :: inputfile

if (il/=0) then
 if(read_file(inputfile,il) /= 1) stop 'error in inputfile'
endif

dp=.true. ; exc=.false.; plexc=.false.
code='dp';
if(read_string('exciton',7)>0) then
 dp=.false. ;  exc  =.true.; plexc=.false.
 code='exc'
endif
if(read_string('plot_exciton',12)>0 .or. read_string('analysis_exciton',16)>0 ) then
 dp=.false. ;  exc  =.false.; plexc =.true.
 code='plexc'
endif

if(dp)  call mesg('initdp','',idum,idum)
if(exc) call mesg('initexc','',idum,idum)
if(plexc) call mesg('initplexc','',idum,idum)

end
!!***

!{\src2tex{textfont=tt}}
!!****p* Multi/mesg
!! NAME
!! mesg
!!
!! FUNCTION
!! Message subroutine (beginning message, error messages, warnings, etc) 
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!!
!! SOURCE


subroutine mesg(typeofmesg,content,value1,value2)
use dpdef
implicit none

integer value1, value2
character *(*) :: typeofmesg, content

if (typeofmesg == 'initdp') then
  write(uout,*) 'program DP, version ', VERSION
  write(uout,*) 'built: ', BUILT
  write(uout,*) 'using svn revision :', REVISION
  write(uout,*) 'DP (Dielectric Properties)'
  write(uout,*) 'DP is a TDDFT linear response code, working in reciprocal space'
  write(uout,*) 'on a plane-waves basis, and in frequency domain'
  write(uout,*)
  write(uout,*) 'Copyright (C) 1998-2010 Valerio Olevano, Lucia Reining, Francesco Sottile'
  write(uout,*) 'A list of contributors is available, see CONTRIBUTORS'
  write(uout,*) 'This file is distributed under the terms of the'
  write(uout,*) 'Scientific Software Open Source Academic For Free License, see COPYING'
  write(uout,*) 'or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html'
  write(uout,*)
  write(uout,*)
  write(uout,*) 'DP starts:'

elseif(typeofmesg .eq. 'initexc') then
  write(uout,*) '        __   ____   ___    __'
  write(uout,*) '\    ___) \  \  /  /  /  __)'
  write(uout,*) ' |  (__    \  \/  /  |  /'
  write(uout,*) ' |   __)    >    <   | |'
  write(uout,*) ' |  (___   /  /\  \  |  \__'
  write(uout,*) '/       )_/  /__\  \__\    )_'
  write(uout,*) ''
  write(uout,*) ''
!FIXME the version here is DP version!
  write(uout,*) 'program EXC version ',VERSION 
  write(uout,*) 'built: ',BUILT
  write(uout,*) 'using svn revision :', REVISION
  write(uout,*)
  write(uout,*) 'calculate dielectric properties'
  write(uout,*) 'Bethe-Salpeter equation code in frequency domain'
  write(uout,*) '         reciprocal space on a transitions basis'
  write(uout,*) ''
  write(uout,*) 'Copyright (C) 1992-2010, Lucia Reining, Valerio Olevano,'
  write(uout,*) 'Francesco Sottile, Stefan Albrecht, Giovanni Onida.'
  write(uout,*) ''
  write(uout,*) 'This program is free software; you can redistribute it'
  write(uout,*) 'and/or modify it under the terms of the GNU General '
  write(uout,*) 'Public License.'
  write(uout,*) ''
  write(uout,*) 'This program is distributed in the hope that it will be'
  write(uout,*) 'useful, but WITHOUT ANY WARRANTY; '
  write(uout,*) ''
  write(uout,*) ''
  write(uout,*) 'EXC starts:'

elseif(typeofmesg .eq. 'initplexc') then
!FIXME the version here is DP version!
  write(uout,*) 'Plot exciton',VERSION 
  write(uout,*) 'built: ',BUILT
  write(uout,*) 'using svn revision :', REVISION
  write(uout,*)
  write(uout,*) 'PLEXC starts:'

elseif(typeofmesg .eq. 'warning') then
  write(uout,*)
  write(uout,*)'????????????????????????????????????????????????????? '
  write(uout,*) ' WARNING WARNING WARNING WARNING :: '
  write(uout,*)
  write(uout,*) '  ',content 
  write(uout,*)'????????????????????????????????????????????????????? '
  write(uout,*)
elseif(typeofmesg .eq. 'error') then
  write(uout,*)
  write(uout,*)'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX '
  write(uout,*) ' ERROR   ERROR   ERROR   ERROR   ERROR '
  write(uout,*)
  write(uout,*) ' PROGRAM WILL STOP ::'
  write(uout,*)
  write(uout,*) '  ',content 
  write(uout,*)'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX '
  write(uout,*)
  stop
elseif(typeofmesg .eq. 'unmatch') then
  write(uout,*)
  write(uout,*)'????????????????????????????????????????????????????? '
  write(uout,*) ' WARNING WARNING WARNING WARNING :: '
  write(uout,*)
  write(uout,*) ' kss file contains ', value1, content
  write(uout,*) '  assuming expert user,  the calculation will be done'
  write(uout,*) '  with the first ',value2,content,' of the file.'
  write(uout,*) '????????????????????????????????????????????????????? '
  write(uout,*)
elseif(typeofmesg .eq. 'over') then
  write(uout,*)
  write(uout,*)'????????????????????????????????????????????????????? '
  write(uout,*) ' WARNING WARNING WARNING WARNING :: '
  write(uout,*)
  write(uout,*) ' kss file contains only ', value1, content
  write(uout,*) '       instead of ', value2, ' required;'
  write(uout,*) '       the calculation will be done with ',content,' = ', value1
  write(uout,*)'????????????????????????????????????????????????????? '
  write(uout,*)
elseif(typeofmesg .eq. 'shell') then
  write(uout,*) '????????????????????????????????????????????????????? '
  write(uout,*) ' WARNING WARNING WARNING WARNING :: '
  write(uout,*)
  write(uout,*) ' ',content,' G-shell not closed ', value1
  write(uout,*) '      run will continue with ', value2
  write(uout,*)'????????????????????????????????????????????????????? '
  write(uout,*)
endif

end

!!***


!{\src2tex{textfont=tt}}
!!****p* Multi/print_headline
!! NAME
!! print_headline
!!
!! FUNCTION
!! Print title of subroutine
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!!
!! SOURCE

subroutine print_headline()

 use dpdef
 implicit none

 character (len=62) :: mesgtot
 integer :: nlen,nstar

 nlen=LEN_TRIM(headline)
 if (nlen < 60) then
  nstar = (60 - nlen)/2 
  if(mod(nlen,2)==1) then 
   mesgtot=REPEAT("*", nstar)//" "//trim(headline)//" "//REPEAT("*", nstar+1)
  else
   mesgtot=REPEAT("*", nstar)//" "//trim(headline)//" "//REPEAT("*", nstar) 
  endif
 else
   mesgtot="******* "//trim(headline)
 endif

 write(uout,*)
 write(uout,'(1x,a)') mesgtot
 write(uout,*)

end subroutine print_headline
!!***



!{\src2tex{textfont=tt}}
!!****p* Multi/print_footline
!! NAME
!! print_footline
!!
!! FUNCTION
!! Print footline of subroutine
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!!
!! SOURCE
subroutine print_footline()

 use dpdef
 implicit none

 write(uout,*)
 write(uout,'(1x,a)') REPEAT("*", 62)
 write(uout,*)

end subroutine print_footline
!!***


!{\src2tex{textfont=tt}}
!!****p* Multi/printcm
!! NAME
!! printcm
!!
!! FUNCTION
!! Print a Complex Matrix 
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! ckxclda, creation_chi0, creation_chi0drude
!!
!! SOURCE

 subroutine printcm(a,n,m)

 use dpdef
 implicit none

 integer row,column,n,m
 complex a(n,m)

 write(uout,50) (column, column=1,9)
 do row = 1, 9
   write(uout,100) row, (real(a(row,column)), column=1,9)
   write(uout,110) (aimag(a(row,column)), column=1,9)
   write(uout,*)
 enddo
 write(uout,*)
50  format(5x,9(i2,6x))
100 format(i1,1x,9g12.3)
110 format(2x,9g12.3)

 end
!!***
