!{\src2tex{textfont=tt}}
!!****p* main/prep_matel_drude
!! NAME
!! prep_matel_drude
!!
!! FUNCTION
!! 
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!! PARENTS
!! main
!!
!! SOURCE
 subroutine prep_matel_drude(iparam,trans,elecstr)
 use dpdef
 use verbose
 use ggwdef
 implicit none
 type(dpparam) iparam
 type(transition) trans(iparam%nt)
 type(electronic_structure) elecstr

 integer isppol,ik,iv
#ifdef MPI
 include 'mpif.h'
 integer ierr,rang,nprocs
 call mpi_comm_size(mpi_comm_world,nprocs,ierr)
 call mpi_comm_rank(mpi_comm_world,rang,ierr)
 if (rang == 0)  then
#endif

 if (iverbose > 2) call uverbose('b','prep_matel_drude')
 if (iverbose > 0) then
    write(uout,*) '**********  Preparing mat el for calculating drude  ************'
    write(uout,*)
 endif
#ifdef MPI
 endif
#endif

 do isppol = 1, elecstr%nsppol
  do ik=1,iparam%nkbz
    do iv = iparam%lomo, iparam%nbnds
       if (iverbose > 2) print *,'ik,iv,isppol = ',ik,iv,isppol
       trans(ik+iparam%nkbz*(iv-iparam%lomo)+(isppol-1)*iparam%nkbz*(iparam%nbnds-iparam%lomo+1))%k = ik
       trans(ik+iparam%nkbz*(iv-iparam%lomo)+(isppol-1)*iparam%nkbz*(iparam%nbnds-iparam%lomo+1))%v = iv
       trans(ik+iparam%nkbz*(iv-iparam%lomo)+(isppol-1)*iparam%nkbz*(iparam%nbnds-iparam%lomo+1))%c = iv
       trans(ik+iparam%nkbz*(iv-iparam%lomo)+(isppol-1)*iparam%nkbz*(iparam%nbnds-iparam%lomo+1))%s = isppol
       trans(ik+iparam%nkbz*(iv-iparam%lomo)+(isppol-1)*iparam%nkbz*(iparam%nbnds-iparam%lomo+1))%en = 0
       trans(ik+iparam%nkbz*(iv-iparam%lomo)+(isppol-1)*iparam%nkbz*(iparam%nbnds-iparam%lomo+1))%factocc = 0
   enddo
 enddo
enddo !isppol

#ifdef MPI
 if (rang==0) then
#endif
 if (iverbose > 0) then
    write(uout,*) '                         done     '
    write(uout,*) '****************************************************'
 endif
 if (iverbose > 2) call uverbose('e','prep_matel_drude')
#ifdef MPI
 endif
#endif

 end
!!*** 
