!{\src2tex{textfont=tt}}
!!****p* Multi/uverbose
!! NAME
!! uverbose
!!
!! FUNCTION
!! Verbosity subroutine. It is used only when iverbose>2 to create the tree file.
!!
!! COPYRIGHT
!! Copyright (C) 1998-2007 Valerio Olevano, Lucia Reining, Francesco Sottile
!!  A list of contributors is available, see CONTRIBUTORS
!!  This file is distributed under the terms of the
!!  Scientific Software Open Source Academic For Free License, see COPYING
!!  or http://lab-neel.grenoble.cnrs.fr/etsf/dp/home/scientificsoftware.html
!!
!!
!! SOURCE

subroutine uverbose(beginend,string)
use verbose
implicit none
character(len=1) :: beginend
character *(*) string
character*50 space
integer ind
space=''
if (beginend == 'b') then
  spaces=spaces+1
  if(spaces > 0) then
   do ind=1,spaces-1
     space=trim(space)//'|** '
   enddo
   space=trim(space)//'|--'
  endif
  write(77,*)trim(space)//'begin ',trim(string)
elseif (beginend == 'e') then
  if(spaces > 0) then
   do ind=1,spaces-1
     space=trim(space)//'|**'
   enddo
   space=trim(space)//'|--'
  endif
  write(77,*)trim(space)//'end ',trim(string)
  spaces=spaces-1
endif
end
!!***

subroutine uverbose_loop(beginend,string)
use verbose
use dpdef
implicit none

character(len=1) :: beginend
character *(*) string

double precision, save :: start = 0.
double precision :: timestamp
integer :: YY,MM,DD,HH,m,s
integer, save :: imatel,loopstep


if (beginend == 'b') then
  write(77,*) '         loop in ',trim(string),' started'
  call get_time2(timestamp,YY,MM,DD,HH,m,s)
  start = timestamp
  imatel=0; loopstep= 1
elseif (beginend == 'l') then
  imatel=imatel+1
  if (imatel > loopnmatel*loopperc / 100 * loopstep) then        
   call get_time2(timestamp,YY,MM,DD,HH,m,s)
   write(77,'(a,i5,a,f10.2,a,f10.2,a)') '           done', loopstep *loopperc ,' % in ',  timestamp-start, &
               ' seconds - time expected to complete loop:',  (timestamp-start)*100/(loopstep *loopperc),' seconds'
   loopstep= loopstep +1 
  endif
elseif (beginend == 'e') then
  write(77,*) '         loop in ',trim(string),' completed'
endif

end 
